bgas = {};

--needs moudle bgas
--lineType 2/bgas
function bgas:load(bgaName)	
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moBGAs.values.bgas ~= nil and moBGAs.values.bgas[bgaName] ~= nil then
		for bga=1, #moBGAs.values.bgas[bgaName] do
			if moBGAs.values.bgas[bgaName][bga] ~= nil then
				local bgaGeneral = moBGAs.values.bgas[bgaName][bga].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];			
				
				if #moBGAs.values.bgas[bgaName] > 1 and bga ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = bgas.returnLineHelpIconClick
				isLineTable.helpTxt = "Click BgaName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				isLineTable.ownValues = {bgaName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = bgaGeneral.object.nodeId;
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;				
				local isNearObject = moModule:nearPlayerPosition(bgaGeneral.object, 30);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = bgas.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. bgaGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = bgaGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				
				local bgaOutput = moBGAs.values.bgas[bgaName][bga].output;
				if bgaOutput ~= nil and #bgaOutput > 0 then
					local outputTable = bgaOutput[1];
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];
					isLineTable.ownValues = {bgaName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 80;	--width prozent
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = outputTable.fillTypeName;
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = outputTable.fillLevel;
					isLineTable.txt[2].clickCallback = bgas.returnClickFillLevelCapacityTotal;
					isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
					isLineTable.txt[2].txtPos = 2;
				end;
				local bgaInput = moBGAs.values.bgas[bgaName][bga].input;
				if bgaInput ~= nil and #bgaInput > 0 then
					if #moBGAs.values.bgas[bgaName][bga].input > 0 and #moBGAs.values.bgas[bgaName][bga].output > 0 then
						isLineTable.txt[1].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 0};
						isLineTable.txt[2].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 2};
					end;					
					local inputTable = bgaInput[1];
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];
					isLineTable.ownValues = {bgaName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 80;	--width prozent
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
					isLineTable.txt[1].bold = moModule.values.txtBold;					
					if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
						isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
						isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
						isLineTable.txt[1].clickCallback = bgas.returnClickFillTypesTotal;						
					else
						isLineTable.txt[1].txt = inputTable.fillTypeName;
					end;					
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
					isLineTable.txt[2].bold = moBGAs.values.txtBold;					
					isLineTable.txt[2].txt = inputTable.percentageCapacity.. "%";
					isLineTable.txt[2].clickCallback = bgas.returnClickFillLevelCapacityTotal;
					isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};
					isLineTable.txt[2].txtPos = 2;
				end;
				---BGA bunkerSilos
				local bunkerSilos = moBGAs.values.bgas[bgaName][bga].bunkerSilos;
				if bunkerSilos ~= nil and #bunkerSilos > 0 then					
					for bunkerIndex=1, #bunkerSilos do
						local bunkerGeneral = moBGAs.values.bgas[bgaName][bga].bunkerSilos[bunkerIndex].general[1];						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.lineClickHelp = true;
						isLineTable.lineClickHelpCallback = bgas.returnLineHelpIconClick
						isLineTable.helpTxt = "Click BunkerSilo/%/Fermenting or .... ++ for more info (or MapHotSpot)";
						
						isLineTable.ownValues = {bgaName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].nodeId = bunkerGeneral.object.nodeId;
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
						isLineTable.txt[1].bold = true;				
						local isNearObject = moModule:nearPlayerPosition(bunkerGeneral.object, 50);				
						if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = bgas.returnClickObjectName;end;				
						if isNearObject ~= nil and isNearObject then
							isLineTable.txt[1].txt = ">>".. bunkerGeneral.objectName.. "<<";
						else
							isLineTable.txt[1].txt = bunkerGeneral.objectName;
						end;
						--isLineTable.txt[1].txtPos = 1;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bgaName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						local color = moModule.values.txtColor;
						if bunkerGeneral.fermentingColor ~= nil then color = Utils.getNoNil(moColors.prozent[bunkerGeneral.fermentingColor], 1);end;
						isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkerfermenting", nil, "Ferment");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent						
						isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.fermentingPercent.. "%";
						isLineTable.txt[2].txtPos = 2;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bgaName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkercompact", nil, "Compression");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.compactedPercent.. "%";
						isLineTable.txt[2].txtPos = 2;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bgaName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkercompactfilllevel", nil, "CompactFill");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.compactedFillLevel;
						isLineTable.txt[2].txtPos = 2;
						
						local bunkerOutput = moBGAs.values.bgas[bgaName][bga].bunkerSilos[bunkerIndex].output;
						if bunkerOutput ~= nil and #bunkerOutput > 0 then
							local outputTable = bunkerOutput[1];
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];
							isLineTable.ownValues = {bgaName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = outputTable.fillTypeName;
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = outputTable.fillLevel;
							isLineTable.txt[2].txtPos = 2;
						end;
						local bunkerInput = moBGAs.values.bgas[bgaName][bga].bunkerSilos[bunkerIndex].input;
						if bunkerInput ~= nil and #bunkerInput > 0 then
							local inputTable = bunkerInput[1];																				
							lineTable[#lineTable+1] = {};							
							isLineTable = lineTable[#lineTable];
							isLineTable.ownValues = {bgaName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;							
							if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
								isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
								isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
								isLineTable.txt[1].clickCallback = bgas.returnClickFillTypesTotal;						
							else
								isLineTable.txt[1].txt = inputTable.fillTypeName;
							end;							
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = inputTable.fillLevel;
							isLineTable.txt[2].txtPos = 2;
						end;
						
					end;
				end;
				---BGA bunkerSilos
			end;
		end;
	end;
	bgas[bgaName] = {output=lineTable};
end;

function bgas.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(bgas[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function bgas.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = bgas[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = bgas[args.ownValues[1]].output[args.line].txt[2].ownValues[2];						
			local flipFillLevel = bgas[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
			local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");						
			local prozent = ""
			if flipFillLevel ~= nil then prozent = "%";end;
			moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
		
		end;
	end;
end;

function bgas.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = bgas[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;			
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;

function bgas.returnClickObjectName(...)
	if ... ~= nil then
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local bgaName = args.ownValues[1];			
			if bgas[bgaName] ~= nil and bgas[bgaName].output ~= nil and bgas[bgaName].output[args.line] ~= nil then
				local nodeId = bgas[bgaName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);	
			end;			
		end;		
	end;
end;

function bgas.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.bgas.isRunning = true;moModule.active.bgas.last = moModule.time.min+moModule.time.delay;		
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local bgaName = args.ownValues[1];			
			bgas:load(bgaName);
			return bgas[bgaName].output;
		end;
	end;	
end;

function bgas.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--bgas:load();	
end;

function bgas:generateCmd(bgaName)
	local _, errorTable = 0, {};
	function insertCmd(bgaName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local bgaNameTemp = tostring(bgaName):lower();
		local languageName = moLanguageXml:getTxt(bgaNameTemp, nil, bgaName);
		newCmdTable.cmdTable[1] = {
			cmdName = "bgas_".. bgaName;			
			displayName = moLanguageXml:getTxt("bgas", nil, "BGAs").. " ".. tostring(languageName);	
			multiple = true;
			sortBy = "BGAs";
			infoTxt = "Zeigt alle BGAs an (".. tostring(languageName).. ")";
			helpTxt = "View all BGAs (".. tostring(bgaName).. ")";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = bgas.giveOutputTable; --a function
			ownValues = {bgaName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate bgas ".. tostring(bgaName).. " Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if bgaName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "bgas_".. bgaName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(bgaName);end;
	else
		if moBGAs.values.bgas ~= nil then
			for bgaName, _ in pairs (moBGAs.values.bgas) do
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "bgas_".. bgaName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(bgaName, moModule:getObjectIds(moBGAs.values.bgas[bgaName], false));end;
			end;
		end;
	end;	
end;		